﻿/**
テスト専用ダイアログ。
*/
module nemuxi.test.debugdialog;

debug import std.stdio: wl = writefln, pl = printf;
debug(debugdialog) void main() {}

import win32.windows;

//import nemuxi.base;
//import nemuxi.image.font;
import nemuxi.negui.system.base;
import nemuxi.negui.draw.font;
import nemuxi.negui.negui;
import nemuxi.negui.window.newindow;
import nemuxi.negui.window.dialog.dialog;
import nemuxi.negui.control.control;
import nemuxi.negui.control.group;
import nemuxi.negui.control.editbox.editbox;
import nemuxi.negui.control.updown.updown;
import nemuxi.negui.control.hotkey.hotkey;
import nemuxi.negui.control.dtp.datetimepicker;
import nemuxi.negui.control.editbox.richedit;
import nemuxi.negui.input.keyboard.keyboard;
import nemuxi.negui.input.keyboard.accelerator;


debug{} else {static assert(false, "debug only!");}
class DebugDialog: ModalDialog {
	enum CTRL: ITEM_ID {
		INPUT=1,
		UD,
		HOT,
		DTP1,
		DTP2,
		RE,
	}
	
	Font font;
	ControlGroup group;
	EditLine Input;
	UpDown spin;
	HotKey hot;
	DateTimePicker[2] dtp;
	RichEdit re;

	this(NeWindow Owner) {
		GUIINFO NeGuiInfo;
		NeGuiInfo.Owner   = Owner;
		//NeGuiInfo.Style   = WS_THICKFRAME;



		super(&NeGuiInfo);

		size(300,300);
	}
	protected override {
		void OnDestroy() {
			delete font;
			super.OnDestroy();
		}
		void OnCreate() {
			super.OnCreate();
			caption=true;
			haveSystemMenu=true;
			frameThick=true;
			maxButton=1;
			taskBar=1;
			
			font=new Font(Font.STOCK.MESSAGE);
			
			Input = new EditLine(this, CTRL.INPUT);
			Input.move(0,0,100,30);

			spin =new UpDown(this, CTRL.UD, UpDown.POSITION.RIGHT);
			//spin.move(101,101,100,100);
			spin.buddy = Input;
			spin.range(-1000,1000);

			spin.value=159;
			spin.reLoad;
			

			HOTKEYVALUE hk;
			hk.modToHotkey(MOD.SHIFT);
			hk.Key = KEY.D;
			
			hot = new HotKey(this, CTRL.HOT);
			hot.move(100,0,200,30);
			hot.rule(HotKey.RULE.NONE, HOTKEY.EXT);
			hot.value
			=hk;


			dtp[0] = new DatePicker(this, CTRL.DTP1);
			dtp[0].move(0, 40, 200, 30);
			dtp[1] = new TimePicker(this, CTRL.DTP2);
			dtp[1].move(0, 80, 200, 30);
			dtp[1].value=new DateTime(
				1999, 12, 31,
				23, 59, 59, 999
			);

			re = new RichEdit(this,CTRL.RE);
			re.move(0, 120, 200, 100);
			

			group = new ControlGroup(
				Input, spin, hot, dtp[0], dtp[1],
				re
			);
			group.font = font;

	Accelerator ac;
		ACCELERATOR[2] key;
		key[0].type    = cast(ACCELERATOR.TYPE)(ACCELERATOR.TYPE.VIRTKEY | ACCELERATOR.TYPE.SHIFT);
		key[0].key     = KEY.A;
		key[0].command = 1;
		
		key[1].type    = cast(ACCELERATOR.TYPE)(ACCELERATOR.TYPE.VIRTKEY | ACCELERATOR.TYPE.CONTROL);
		key[1].key     = KEY.A;
		key[1].command = 1;
		
			//Accelerator.idRegist(LoopOwnerID, this, ac);
		//	accelerator=new Accelerator(key);;
		ACCELERATOR k;
		k.type = cast(ACCELERATOR.TYPE)(ACCELERATOR.TYPE.VIRTKEY | ACCELERATOR.TYPE.SHIFT);
		k.key     = KEY.B;
		k.command = 1;
		auto a=accelerator ;
			a+= k;
		}

		bool OnAccelerator(COMMAND_ID Id) {
			if(super.OnAccelerator(Id)) {
				return true;
			}
			return false;
		}
	}
}


